<?php
#!/usr/bin/php -q

//STANDARD SCRIPT SERVER HEADER!!!
$no_http_headers = true;

/* display No errors */
error_reporting(E_ERROR);

include_once(dirname(__FILE__) . "/../include/config.php");
include_once(dirname(__FILE__) . "/../lib/snmp.php");
include_once(dirname(__FILE__) . "/../lib/ping.php");

if (!isset($called_by_script_server)) {
	array_shift($_SERVER["argv"]);
	print call_user_func_array("ss_fping", $_SERVER["argv"]);
}
//End header.

function ss_fping($hostname, $ping_sweeps=6)
{
	$ping = new Net_Ping;

	$total_time = 0;
	$failed_results = 0;
	$i = 0;
	$ping->host["hostname"] = $hostname;
	$ping->retries = 1;
	$max = 0.0;
	$min = 9999.99;
	$dev = 0.0;

	while ($i < $ping_sweeps) {
		$result = $ping->ping(AVAIL_PING,
					PING_ICMP,
					read_config_option("ping_timeout"),
					1);

		if (!$result) {
			$failed_results++;
		}else{
			$total_time += $ping->ping_status;
			if ($ping->ping_status < $min) $min = $ping->ping_status;
			if ($ping->ping_status > $max) $max = $ping->ping_status;
		}

		$i++;
	}

	if ($failed_results == $ping_sweeps) {
		return "loss:100.00";
	}else{
		$loss = ($failed_results/$ping_sweeps) * 100;
	    $avg = $total_time/($ping_sweeps-$failed_results);
		$dev1 = $avg - $min;
		$dev2 = $max - $avg;
		$dev = ($dev1 + $dev2)/2;
		return sprintf("min:%0.4f avg:%0.4f max:%0.4f dev:%0.4f loss:%0.4f", $min, $avg, $max, $dev, $loss);
	}
}
?>